	MODULE MOD_DISP
!
! Altered 28-Mar-2003 : NUM_IONS variable installed.
! Altered 27-Nov-2000 : MASS changed to AT_MASS
!                       Extra species installed. More consistent with CMFGEN.
!
	INTEGER, PARAMETER :: NSPEC=26
	INTEGER, PARAMETER :: NION_MAX=20
	INTEGER, PARAMETER :: NPHOT_MAX=4
	INTEGER, PARAMETER :: MAX_ION=NSPEC*NION_MAX
	INTEGER  NUM_IONS			!Total number of ions present
!
	REAL*8 AT_MASS(NSPEC)
	REAL*8 AT_NO(NSPEC)
        REAL*8 SOL_MASS_FRAC(NSPEC)       	!Solar mass fraction
        REAL*8 SOL_ABUND_HSCL(NSPEC)      	!Solar abundance with H=12.0
!
	CHARACTER*10 SPECIES(NSPEC)
	CHARACTER*2  SPECIES_ABR(NSPEC)
	CHARACTER*12 ION_ID(MAX_ION)
	CHARACTER*5  GEN_ION_ID(NION_MAX)
	INTEGER  SPECIES_LNK(MAX_ION)
	INTEGER SPECIES_BEG_ID(NSPEC)
	INTEGER SPECIES_END_ID(NSPEC)
!                
	TYPE MODEL_ATOM_DATA
!
	  REAL*8, ALLOCATABLE :: XzV_F(:,:)
	  REAL*8, ALLOCATABLE :: XzVLTE_F(:,:)
	  REAL*8, ALLOCATABLE :: LOG_XzVLTE_F(:,:)
	  REAL*8, ALLOCATABLE :: W_XzV_F(:,:)
	  REAL*8, ALLOCATABLE :: DXzV_F(:)
	  REAL*8, ALLOCATABLE :: DXzV(:)
	  REAL*8, ALLOCATABLE :: AXzV_F(:,:)
	  REAL*8, ALLOCATABLE :: EDGEXzV_F(:)
	  REAL*8, ALLOCATABLE :: GXzV_F(:)
!
	  REAL*8 ZXzV
	  REAL*8 GIONXzV_F
!
	  INTEGER, ALLOCATABLE :: F_TO_S_XzV(:)
!
	  INTEGER NXzV_F
	  INTEGER N_XzV_PHOT
	  INTEGER XzV_ION_LEV_ID(NPHOT_MAX)
	  LOGICAL XzV_PRES
	  CHARACTER(LEN=40), ALLOCATABLE :: XzVLEVNAME_F(:)
	  CHARACTER(LEN=11) XzV_OSCDATE
	  CHARACTER(LEN=11) NEW_XzV_OSCDATE
	END TYPE MODEL_ATOM_DATA
	TYPE (MODEL_ATOM_DATA) ATM(NSPEC*NION_MAX)
C
C Data arrays for full atom.
C
C
	REAL*8, ALLOCATABLE :: R(:)
	REAL*8, ALLOCATABLE :: V(:)
	REAL*8, ALLOCATABLE :: SIGMA(:)
	REAL*8, ALLOCATABLE :: T(:)
	REAL*8, ALLOCATABLE :: ED(:)
	REAL*8, ALLOCATABLE :: CMFGEN_TGREY(:)
	REAL*8, ALLOCATABLE :: dE_RAD_DECAY(:)
!
	REAL*8 ABUND(NSPEC)
!
	REAL*8, ALLOCATABLE :: ROSS_MEAN(:)
	REAL*8, ALLOCATABLE :: FLUX_MEAN(:)
	REAL*8, ALLOCATABLE :: POP_ATOM(:)
	REAL*8, ALLOCATABLE :: MASS_DENSITY(:)
	REAL*8, ALLOCATABLE :: CLUMP_FAC(:)
	REAL*8, ALLOCATABLE :: POPION(:)
!
	REAL*8, ALLOCATABLE :: POPDUM(:,:)
!
!	DATA GEN_ION_ID /'I','II','III','IV','V',
!	1                'VI','VII','VIII','IX','X','XI','XII'/
!
	DATA GEN_ION_ID /'I','2','III','IV','V',
	1                'SIX','SEV','VIII','IX','X','XI','XII',
	1                'XIII','XIV','XV','XSIX','XSEV','X8','X9','XX'/
!
	END MODULE MOD_DISP
