!
! Altered 15-Jul-2010 : Increased MAX_NUM_ISOTOPES from 20 to 50.
!
	MODULE NUC_ISO_MOD
	IMPLICIT NONE
	INTEGER, PARAMETER :: MAX_NUM_DECAY_PATHS=30
	INTEGER, PARAMETER :: MAX_NUM_ISOTOPES=150
	INTEGER NUM_ISOTOPES 
	INTEGER NUM_DECAY_PATHS
	INTEGER NUM_PARENTS
	LOGICAL DO_RAD_DECAYS
!
	REAL*8, POINTER :: RADIOACTIVE_DECAY_ENERGY(:)
!
	TYPE NUC_PARENT_DATA
	  REAL*8, POINTER :: OLD_POP(:)
	  REAL*8, POINTER :: OLD_POP_DECAY(:)
	  INTEGER ISPEC
	END TYPE NUC_PARENT_DATA
!
! We use 
!       POP           to refer to ISOTOP population at the current epoch.
!       OLD_POP       to refer to ISOTOPE population at the previous epoch.
!       OLD_POP_DECAY to refer to ISOTOPE population at the previous epoch,
!                        but corrected for between the current and previous epoch.
!       ISPEC         to the species link in MOD_CMFGEN.
!
	TYPE NUC_ISOTOPE_DATA
	  REAL*8, POINTER :: POP(:)
	  REAL*8, POINTER :: OLD_POP(:)
	  REAL*8, POINTER :: OLD_POP_DECAY(:)
	  REAL*8 MASS
          INTEGER BARYON_NUMBER
	  INTEGER LNK_TO_PAR
	  INTEGER ISPEC
	  LOGICAL STABLE
          CHARACTER*10 SPECIES
	END TYPE NUC_ISOTOPE_DATA
!
	TYPE NUC_DECAY_DATA
	  REAL*8 HALF_LIFE              !seconds
	  REAL*8 DECAY_CONST		!seconds
	  REAL*8 MASS			!AMU
	  REAL*8 DAUGHTER_MASS
	  REAL*8 ENERGY_PER_DECAY
	  INTEGER ISPEC			!Link to species in MOD_CMFGEN
	  INTEGER LNK_TO_ISO		!Link to the corresponding isotope in ISOTOPE_DATA
          INTEGER BARYON_NUMBER
	  INTEGER DAUGHTER_ISPEC
	  INTEGER DAUGHTER_LNK_TO_ISO
          INTEGER DAUGHTER_BARYON_NUMBER
          CHARACTER*10 SPECIES
          CHARACTER*10 DAUGHTER
          CHARACTER*1  SEQUENCE
	END TYPE NUC_DECAY_DATA 
!
	TYPE (NUC_PARENT_DATA)  PAR(MAX_NUM_ISOTOPES)
	TYPE (NUC_ISOTOPE_DATA) ISO(MAX_NUM_ISOTOPES)
	TYPE (NUC_DECAY_DATA)   NUC(MAX_NUM_DECAY_PATHS)
!
	END MODULE NUC_ISO_MOD
