	MODULE MOD_VAR_JREL_V2
	IMPLICIT NONE
!
! These vectors must be saved as they will be used on subsequent iterations.
!
	REAL*8, ALLOCATABLE :: AV_SIGMA(:)
	REAL*8, ALLOCATABLE :: BETA(:)
	REAL*8, ALLOCATABLE :: BETA_FREQ(:)
	REAL*8, ALLOCATABLE :: GAM_RSQ(:)
	REAL*8, ALLOCATABLE :: GAM_REL(:)
	REAL*8, ALLOCATABLE :: GAM_REL_SQ(:)
	REAL*8, ALLOCATABLE :: CON_DELTA(:)
	REAL*8, ALLOCATABLE :: CON_DELTAH(:)
	REAL*8, ALLOCATABLE :: CON_dKdNUH(:)
	REAL*8, ALLOCATABLE :: CON_dNdNUH(:)
	REAL*8, ALLOCATABLE :: CON_dKdNU(:)
	REAL*8, ALLOCATABLE :: CON_dHdNU(:)
!
	REAL*8, ALLOCATABLE :: JNU(:)
	REAL*8, ALLOCATABLE :: JNU_PREV(:)
        REAL*8, ALLOCATABLE :: GAM_RSQHNU(:)
        REAL*8, ALLOCATABLE :: GAM_RSQHNU_PREV(:)
!
	REAL*8, ALLOCATABLE :: TA(:),TB(:),TC(:)
	REAL*8, ALLOCATABLE :: CHI_H(:),CHI_J(:)
	REAL*8, ALLOCATABLE :: DTAU_H(:),DTAU_J(:)
	REAL*8, ALLOCATABLE :: GAM_RSQ_DTAUONQ(:)
	REAL*8, ALLOCATABLE :: Q(:),XM(:),SOURCE(:)
	REAL*8, ALLOCATABLE :: VB(:),VC(:),COH_VEC(:)
	REAL*8, ALLOCATABLE :: HU(:),HL(:),HS(:),HD(:)
	REAL*8, ALLOCATABLE :: P_H(:),P_J(:)
	REAL*8, ALLOCATABLE :: VdJdR_TERM(:),VdHdR_TERM(:)
	REAL*8, ALLOCATABLE :: DELTA(:),DELTAH(:)
	REAL*8, ALLOCATABLE :: W(:),WPREV(:)
	REAL*8, ALLOCATABLE :: PSI(:),PSIPREV(:),PSIPREV_MOD(:)
	REAL*8, ALLOCATABLE :: EPS_A(:),EPS_B(:)
	REAL*8, ALLOCATABLE :: EPS_PREV_A(:),EPS_PREV_B(:)
	REAL*8, ALLOCATABLE :: GAM_RSQJNU_PREV(:)
	REAL*8, ALLOCATABLE :: TA_SAV(:),TB_SAV(:),TC_SAV(:),XM_SAV(:)
!
	REAL*8, ALLOCATABLE :: TX_OLD_d_T(:)
	REAL*8, ALLOCATABLE :: TX_OLD_d_dTdR(:)
!
! These vectors are used by EDD_JREL_VAR_V1
!
	REAL*8, ALLOCATABLE :: dTAUdCHI_H(:,:)
	REAL*8, ALLOCATABLE :: dTAUdCHI_J(:,:)
	REAL*8, ALLOCATABLE :: dHUdCHI(:)
	REAL*8, ALLOCATABLE :: dHLdCHI(:)
	REAL*8, ALLOCATABLE :: dHSdCHI(:)
	REAL*8, ALLOCATABLE :: dHUdTAU(:)
	REAL*8, ALLOCATABLE :: dHLdTAU(:)
	REAL*8, ALLOCATABLE :: EPS_FAC(:)
	REAL*8, ALLOCATABLE :: dRHSdI(:)
	REAL*8, ALLOCATABLE :: dRHSdJ(:)
!
	INTEGER ND_SAV
!
	END MODULE MOD_VAR_JREL_V2
!
! Subroutine to allocate the required vectors.
!
	SUBROUTINE ALLOC_MOD_VAR_JREL_V2(ND)
	USE MOD_VAR_JREL_V2
	IMPLICIT NONE
!
	INTEGER ND
	INTEGER IOS
	INTEGER LUER,ERROR_LU
	EXTERNAL ERROR_LU
!
	LUER=ERROR_LU()
!
	IF(.NOT. ALLOCATED(AV_SIGMA))THEN
!
	  ND_SAV=ND
	  ALLOCATE (AV_SIGMA(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (BETA(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (BETA_FREQ(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (GAM_RSQ(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (GAM_REL(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (GAM_REL_SQ(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CON_DELTA(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CON_DELTAH(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CON_dKdNUH(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CON_dNdNUH(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CON_dKdNU(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CON_dHdNU(ND),STAT=IOS)
	  IF(IOS .NE. 0)THEN
	    WRITE(LUER,*)'Unable to allocate memory(1) in ALLOC_MOD_J_REL'
	    WRITE(LUER,*)'STAT=',IOS
	    STOP
	  END IF
!
          IF(IOS .EQ. 0)ALLOCATE (JNU(ND),STAT=IOS)
          IF(IOS .EQ. 0)ALLOCATE (JNU_PREV(ND),STAT=IOS)
          IF(IOS .EQ. 0)ALLOCATE (GAM_RSQHNU(ND),STAT=IOS)
          IF(IOS .EQ. 0)ALLOCATE (GAM_RSQHNU_PREV(ND),STAT=IOS)
	  IF(IOS .NE. 0)THEN
	    WRITE(LUER,*)'Unable to allocate memory(2) in ALLOC_MOD_J_REL'
	    WRITE(LUER,*)'STAT=',IOS
	    STOP
	  END IF
!
	  ALLOCATE (TA(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TB(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TC(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CHI_H(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (CHI_J(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (DTAU_H(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (DTAU_J(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (GAM_RSQ_DTAUONQ(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (Q(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (XM(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (SOURCE(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (VB(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (VC(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (COH_VEC(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (HU(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (HL(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (HS(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (HD(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (P_H(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (P_J(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (VdJdR_TERM(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (VdHdR_TERM(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (DELTA(ND),STAT=IOS)
          IF(IOS .EQ. 0)ALLOCATE (DELTAH(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (W(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (WPREV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (PSI(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (PSIPREV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (PSIPREV_MOD(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (EPS_A(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (EPS_B(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (EPS_PREV_A(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (EPS_PREV_B(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (GAM_RSQJNU_PREV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TX_OLD_d_T(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TX_OLD_d_dTdR(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TA_SAV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TB_SAV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TC_SAV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (XM_SAV(ND),STAT=IOS)
	  IF(IOS .NE. 0)THEN
	    WRITE(LUER,*)'Unable to allocate memory(3) in ALLOC_MOD_VAR_JREL'
	    WRITE(LUER,*)'STAT=',IOS
	    STOP
	  END IF
!
	  IF(IOS .EQ. 0)ALLOCATE(dTAUdCHI_H(ND,ND))
	  IF(IOS .EQ. 0)ALLOCATE(dTAUdCHI_J(ND,ND))
	  IF(IOS .EQ. 0)ALLOCATE(dHUdCHI(ND))
	  IF(IOS .EQ. 0)ALLOCATE(dHLdCHI(ND))
	  IF(IOS .EQ. 0)ALLOCATE(dHSdCHI(ND))
	  IF(IOS .EQ. 0)ALLOCATE(dHUdTAU(ND))
	  IF(IOS .EQ. 0)ALLOCATE(dHLdTAU(ND))
	  IF(IOS .EQ. 0)ALLOCATE(EPS_FAC(ND))
	  IF(IOS .EQ. 0)ALLOCATE(dRHSdI(ND))
	  IF(IOS .EQ. 0)ALLOCATE(dRHSdJ(ND))
	  IF(IOS .NE. 0)THEN
	    WRITE(LUER,*)'Unable to allocate memory(3) in ALLOC_MOD_VAR_JREL'
	    WRITE(LUER,*)'STAT=',IOS
	    STOP
	  END IF
	END IF
!
        JNU_PREV(:)=0.0D0
        GAM_RSQHNU_PREV(:)=0.0D0
!
	IF(ND_SAV .EQ. ND)THEN
	  RETURN
	ELSE
	  WRITE(LUER,*)'Error in ALLOC_MOD_VAR_JREL'
	  WRITE(LUER,*)'At present allocation size cannot be changed'
	  WRITE(LUER,*)'Need to modify ALLOC_MOD_VAR_JREL'
	  STOP
	END IF
!
	RETURN
	END
