        MODULE MOD_VAR_MOM_J_CMF
	IMPLICIT NONE
!
	INTEGER VEC_LENGTH
	REAL*8, ALLOCATABLE :: TA(:)
	REAL*8, ALLOCATABLE :: TB(:)
	REAL*8, ALLOCATABLE :: TC(:)
	REAL*8, ALLOCATABLE :: DTAU(:)
	REAL*8, ALLOCATABLE :: RSQ_DTAUONQ(:)
	REAL*8, ALLOCATABLE :: XM(:)
	REAL*8, ALLOCATABLE :: SOURCE(:)
	REAL*8, ALLOCATABLE :: Q(:)
	REAL*8, ALLOCATABLE :: JNU(:)
	REAL*8, ALLOCATABLE :: RSQ_HNU(:)
	REAL*8, ALLOCATABLE :: VB(:)
	REAL*8, ALLOCATABLE :: VC(:)
	REAL*8, ALLOCATABLE :: HU(:)
	REAL*8, ALLOCATABLE :: HL(:)
	REAL*8, ALLOCATABLE :: HS(:)
	REAL*8, ALLOCATABLE :: GAM(:)
	REAL*8, ALLOCATABLE :: GAMH(:)
	REAL*8, ALLOCATABLE :: W(:)
	REAL*8, ALLOCATABLE :: WPREV(:)
	REAL*8, ALLOCATABLE :: PSI(:)
	REAL*8, ALLOCATABLE :: PSIPREV_MOD(:)
	REAL*8, ALLOCATABLE :: PSIPREV(:)
	REAL*8, ALLOCATABLE :: EPS_A(:)
	REAL*8, ALLOCATABLE :: EPS_B(:)
	REAL*8, ALLOCATABLE :: EPS_PREV_A(:)
	REAL*8, ALLOCATABLE :: EPS_PREV_B(:)
	REAL*8, ALLOCATABLE :: TX_OLD_d_T(:)
	REAL*8, ALLOCATABLE :: TX_OLD_d_dTdR(:)
	REAL*8, ALLOCATABLE :: JNUM1(:)
	REAL*8, ALLOCATABLE :: RSQ_HNUM1(:)
!
	END MODULE MOD_VAR_MOM_J_CMF
!
	SUBROUTINE MOD_VAR_MOM_ALLOC(ND)
	USE MOD_VAR_MOM_J_CMF
	IMPLICIT NONE
!
	INTEGER ND
	INTEGER IOS
	INTEGER LUER
	INTEGER ERROR_LU
	EXTERNAL ERROR_LU
!
	IF(.NOT. ALLOCATED(TA))THEN
	  ALLOCATE (TA(ND),TB(ND),TC(ND),DTAU(ND),RSQ_DTAUONQ(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (XM(ND),SOURCE(ND),Q(ND),JNU(ND),RSQ_HNU(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (VB(ND),VC(ND),HU(ND),HL(ND),HS(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (GAM(ND),GAMH(ND),W(ND),WPREV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (PSI(ND),PSIPREV_MOD(ND),PSIPREV(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (EPS_A(ND),EPS_B(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (EPS_PREV_A(ND),EPS_PREV_B(ND),STAT=IOS)
	  IF(IOS .EQ. 0)ALLOCATE (TX_OLD_d_T(ND),TX_OLD_d_dTdR(ND),STAT=IOS)
!
! NB: JNUM1 and RSQHNUM1 must not be zeroed in the routine.
!
	  IF(IOS .EQ. 0)ALLOCATE (JNUM1(ND),RSQ_HNUM1(ND),STAT=IOS)
	  VEC_LENGTH=ND
!
	  IF(IOS .NE. 0)THEN
	    LUER=ERROR_LU()
	    WRITE(LUER,*)'Unable to allocate memory in MOD_VAR_MOM_ALLOC'
	    WRITE(LUER,*)'STAT=',IOS
	    STOP
	  END IF
	END IF
!
! Initialize all vectors.
!
	TA=0.0D0; TB=0.0D0; TC=0.0D0; DTAU=0.0D0; RSQ_DTAUONQ=0.0D0
	XM=0.0D0; SOURCE=0.0D0; Q=0.0D0; JNU=0.0D0; RSQ_HNU=0.0D0
	VB=0.0D0; VC=0.0D0; HU=0.0D0; HL=0.0D0; HS=0.0D0
	EPS_A=0.0D0; EPS_B=0.0D0; EPS_PREV_A=0.0D0; EPS_PREV_B=0.0D0
	TX_OLD_d_T=0.0D0; TX_OLD_d_dTdR=0.0D0
	GAM=0.0D0; GAMH=0.0D0; W=0.0D0; WPREV=0.0D0
	PSI=0.0D0; PSIPREV_MOD=0.0D0; PSIPREV=0.0D0
!
	RETURN
	END	
