	PROGRAM TST_GRIEM
	USE GEN_IN_INTERFACE
	IMPLICIT NONE
	INTEGER ND
	INTEGER, PARAMETER :: ND_MAX=5
	INTEGER, PARAMETER :: NFREQ=50
C
	REAL*8 PROF(NFREQ,ND_MAX)
	REAL*8 NU(NFREQ),LAM(NFREQ),LOGLAM(NFREQ)
	REAL*8 ED_IN(ND_MAX),TEMP_IN(ND_MAX),VDOP_IN(ND_MAX)
	REAL*8 Z_IN,AMASS_IN
	INTEGER NL,NUP
C
	INTEGER I
	REAL*8 RYDBERG_HYDROGEN
	EXTERNAL RYDBERG_HYDROGEN
	REAL*8 DEL_NU,T1,RHYD,LAM_ZERO,NU_ZERO
C
	REAL*8 KTH_LAM(17),KTH_GRI(17)
	DATA KTH_LAM/0,0.1,0.4,0.8,1.20,1.60,2.0,2.4,2.8,3.2,3.6,
	1             4.0,5.0,6.0,7.0,10.0,20.0/
	DATA KTH_GRI/-10.691,-10.718,-11.130,-12.448,-14.614,-16.122,
	1              -16.397,-16.602,-16.722,-16.917,-17.044,
	1              -17.158,-17.396,-17.590,-17.754,
	1              -18.131,-18.863/
C
	ED_IN(1:ND_MAX)=10.0**10
	TEMP_IN(1:ND_MAX)=1.0
!
1000	CONTINUE
	CALL GEN_IN(NL,'NL for species[NL=0 stops program]')
	IF(NL .EQ. 0)STOP
	CALL GEN_IN(NUP,'NUP for species')
	ED_IN(1:ND)=LOG10(ED_IN(1:ND))
	CALL GEN_IN(ED_IN,ND,ND_MAX,'Log10(Electron density[cm^-3])')
	ED_IN(1:ND)=10**(ED_IN(1:ND))
	CALL GEN_IN(TEMP_IN,ND,ND_MAX,'T (10^4) K')
	VDOP_IN(1:ND)=0.0
C
	Z_IN=1.0
	AMASS_IN=1.0
C
	DEL_NU=5.0/2.998E+05
	T1=1.1
	NU(1)=0.0
	DO I=2,NFREQ
	  DEL_NU=DEL_NU*T1
	  NU(I)=NU(I-1)+DEL_NU
	END DO
C
C Convert from FREQ space to Angstroms. DWS is the distnace from
C line center in Angstroms.
C
	RHYD=RYDBERG_HYDROGEN()		!cm^{-1}
	NU_ZERO=RHYD*Z_IN*Z_IN*(NUP-NL)*(NUP+NL)/NUP/NUP/NL/NL	!cm^-1
	LAM_ZERO=1.0E+08/NU_ZERO				!Angstroms.
	DO I=1,NFREQ
	  LAM(I)=ABS( NU(I)/(1.0+NU(I)) )*LAM_ZERO
	  IF(LAM(I) .GT. 0)LOGLAM(I)=LOG10(LAM(I))
	END DO
C
	CALL TUNE(1,'SET_GRIEM')
	CALL SET_GRIEM(PROF,NU,NFREQ,
	1               ED_IN,TEMP_IN,VDOP_IN,ND,
	1               NL,NUP,AMASS_IN,Z_IN)
	CALL TUNE(2,'SET_GRIEM')
	CALL TUNE(3,' ')
C
	PROF(1:NFREQ,1:ND)=PROF(1:NFREQ,1:ND)/LOG(10.0D0)	!To base 10
	DO I=1,ND
	  CALL DP_CURVE(NFREQ,NU,PROF(1,I))
	END DO
	CALL GRAMON_PGPLOT('\gDV/c','Prof',' ',' ')
	DO I=1,ND
	  CALL DP_CURVE(NFREQ,LAM,PROF(1,I))
	END DO
	CALL GRAMON_PGPLOT('Lam(\A)','Prof',' ',' ')
	DO I=1,ND
	  CALL DP_CURVE(NFREQ-3,LOGLAM(4),PROF(4,I))
	END DO
	CALL GRAMON_PGPLOT('Log \gl(\A)','Prof',' ',' ')
C
	IF(NL .EQ. 2 .AND. NUP .EQ. 3)THEN
	  CALL DP_CURVE(NFREQ,LAM,PROF(1,1))
	  CALL DP_CURVE(17,KTH_LAM,KTH_GRI)
	  CALL GRAMON_PGPLOT('Lam(\gV)','Prof',' ',' ')
	END IF
	GOTO 1000
C
	END
