	MODULE CONSTANTS_MOD
	IMPLICIT NONE
!
! Module contains physical and astrophysical constants of general interest.
! All constants are cgs. Designed to replace function calls in phys_con.f.
!
! Created 7-Jan-2008 :: Based on cur_cmf/subs/phys_con.f
!
	REAL*8, PARAMETER :: SPEED_OF_LIGHT        =2.99792458D+10 	!Exact cm/s
	REAL*8, PARAMETER :: ELECTRON_VOLT         =1.60217733D-12      !ergs
	REAL*8, PARAMETER :: GRAVITATIONAL_CONSTANT=6.67259D-08		!cm^3/gm/s
	REAL*8, PARAMETER :: PLANCKS_CONSTANT      =6.626075D-27	!erg sec
	REAL*8, PARAMETER :: ATOMIC_MASS_UNIT      =1.660540D-24	!gm
	REAL*8, PARAMETER :: ELECTRON_MASS         =9.109389D-28	!gm
	REAL*8, PARAMETER :: BOLTZMANN_CONSTANT    =1.380658D-16	!erg/K
	REAL*8, PARAMETER :: STEFAN_BOLTZ          =5.670400D-05	!ergs/cm^2/K^4
!
	REAL*8, PARAMETER :: RYDBERG_INF     =109737.31534D0		!/cm
	REAL*8, PARAMETER :: RYDBERG_HYDROGEN=109677.6D0		!/cm
	REAL*8, PARAMETER :: RYDBERG_HELIUM  =109722.3D0		!/cm
	REAL*8, PARAMETER :: RYDBERG_CARBON  =109732.3D0		!/cm
	REAL*8, PARAMETER :: RYDBERG_NITROGEN=109733.0D0		!/cm
	REAL*8, PARAMETER :: RYDBERG_OXYGEN  =109733.5D0		!/cm
!
	REAL*8, PARAMETER :: MASS_SUN=1.989D+33  			!gm
	REAL*8, PARAMETER :: RAD_SUN =6.9599D+10			!cm (changed 7-Jan-2008)
	REAL*8, PARAMETER :: LUM_SUN =3.826D+33				!erg/s
	REAL*8, PARAMETER :: TEFF_SUN=5770.0D0				!K
!
	REAL*8, PARAMETER :: ASTRONOMICAL_UNIT=1.49597892D+13		!cm
	REAL*8, PARAMETER :: PARSEC           =3.0856D+18       	!cm
	REAL*8, PARAMETER :: JANSKY           =1.0D-23			!ergs/cm^2/s/Hz
!
	REAL*8, PARAMETER ::           PI=3.141592653589793238462643D0
	REAL*8, PARAMETER ::       FUN_PI=3.141592653589793238462643D0
	REAL*8, PARAMETER :: SECS_IN_YEAR=31557600.0D0     		!365.25*24*60*60
!
	END MODULE CONSTANTS_MOD	
